/* GTK+ Pixbuf Engine
 * Copyright (C) 1998-2000 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Written by Owen Taylor <otaylor@redhat.com>, based on code by
 * Carsten Haitzler <raster@rasterman.com>
 */

#include <gtk/gtkstyle.h>

typedef struct _QtPixbufStyle QtPixbufStyle;
typedef struct _QtPixbufStyleClass QtPixbufStyleClass;

extern GType qt_pixbuf_type_style;

#define QTPIXBUF_TYPE_STYLE              qt_pixbuf_type_style
#define QTPIXBUF_STYLE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), QTPIXBUF_TYPE_STYLE, QtPixbufStyle))
#define QTPIXBUF_STYLE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), QTPIXBUF_TYPE_STYLE, QtPixbufStyleClass))
#define QTPIXBUF_IS_STYLE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), QTPIXBUF_TYPE_STYLE))
#define QTPIXBUF_IS_STYLE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), QTPIXBUF_TYPE_STYLE))
#define QTPIXBUF_STYLE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), QTPIXBUF_TYPE_STYLE, QtPixbufStyleClass))

struct _QtPixbufStyle
{
  GtkStyle parent_instance;
};

struct _QtPixbufStyleClass
{
  GtkStyleClass parent_class;
};

void qt_pixbuf_style_register_type (GTypeModule *module);


